var key = "&hearts;";

var onlineNow = new Array()
onlineNow['itani'] = new Array()
onlineNow['serco'] = new Array()
onlineNow['uit'] = new Array()
onlineNow['unaligned'] = new Array()

var onlineOld;

var join;
var part;

var nationId = new Array()
nationId[0] = 'itani';
nationId[1] = 'serco';
nationId[2] = 'uit';
nationId[3] = 'unaligned';

var unNationId = new Array()
unNationId['itani'] = 0;
unNationId['serco'] = 1;
unNationId['uit'] = 2;
unNationId['unaligned'] = 3;

function assembleNations(list){
	onlineOld = array_toSet(onlineNow['itani'].concat(onlineNow['serco'],onlineNow['uit'],onlineNow['unaligned']))
	onlineNow['itani'] = new Array()
	onlineNow['serco'] = new Array()
	onlineNow['uit'] = new Array()
	onlineNow['unaligned'] = new Array()
	
	list = list.split(key);
	i = 0;
	while(list[i]){
		var name = list.splice(0,1);
		var nation = nationId[list.splice(0,1)-1];
		onlineNow[nation].push(name);
	}
	
	//Debug line
	if(useFakeUsers){fakeUserList();}
	
	createJoinPart()
		
	var playerCount = (onlineNow['itani'].length + onlineNow['serco'].length + onlineNow['uit'].length + onlineNow['unaligned'].length)
	if(addUserCount(playerCount)){refreshGraph();}
	$('playerCount').innerHTML = "Active players :: " + playerCount
}


function createNationDisplay(){
	sendDebug("Creating nation display")
	$('itani').innerHTML = addNation("Itani")
	$('serco').innerHTML = addNation("Serco")
	$('uit').innerHTML = addNation("UIT")
	$('unaligned').innerHTML = addNation("Unaligned")
	gNationScrollArea.refresh();
	
	sendDebug("Nation display created")
	

}


function addNation(name){
	sendDebug("Adding nation: " + name)
	if(onlineNow[name.toLowerCase()].length == 0){
		setNationVisibility(unNationId[name.toLowerCase()],false);
	} else {
		setNationVisibility(unNationId[name.toLowerCase()],true);
	}
	
	var construct = "";
	construct += "<h3>" + name +" :: " + onlineNow[name.toLowerCase()].length + "</h3><ul>"
	for(var i = 0; i < onlineNow[name.toLowerCase()].length; i++){
		construct += addCharacter(onlineNow[name.toLowerCase()][i]);
	}
	construct += "</ul></div>"
	return construct;
}

function addCharacter(name){
	var construct = "<li ondblclick=\"openFriendWindow('" + escape(name) + "')\" ";
	if(isFriend(name) && showFriends || (fakeFriends && Math.random()>.70)){
		construct += "class=\"friend"
	} else if(isFoe(name) && showFoes || (fakeFoes && Math.random()>.60)){
		construct += "class=\"foe"
	} else {
		construct += "class=\""
	}
	
	if(enhance){construct += " enhance";}
	
	construct += "\">";
	
	if(guildTagSide == "left"){
		construct += "" + addGuildTag(name) + "<span>" + name + "</span></li>";
	} else if (guildTagSide == "right"){
		construct += "<span>" + name + "</span>" + addGuildTag(name) + "</li>";
	} else if (guildTagSide == "center"){ //Yes, it's a little silly. That's the point!
		name = name.toString();
		firstHalf = name.substr(0,Math.floor(name.length /2))
		secondHalf = name.substr(Math.floor(name.length /2), name.length - Math.floor(name.length /2))
		construct += "<span>" + firstHalf + "</span>" + addGuildTag(name) + "<span>" + secondHalf + "</span></li>";
	}
	
	return construct;
}

function addGuildTag(name){
	if(playersInGuild[name] && showGuildRank){
		var guildTag = playersInGuild[name]["guild"]
			
		if(guildTag.toString() != "undefined"){
			switch(guildTagCaps){
				case -1: guildTag = guildTag.toString().toLowerCase(); break;
				case 1: guildTag = guildTag.toString().toUpperCase(); break;
				default: break;
			}
			var guildRank = playersInGuild[name]["rank"];
			//var showGuildRank = true;
			if(showGuildRank){
				if(guildRank.toString().search("Lieutenant") != -1){
					guildRank = "<img src=\"Images/lieutenant.png\"/>";
				} else if(guildRank.toString().search("Commander") != -1){
					guildRank = "<img src=\"Images/commander.png\"/>"
				} else {
					guildRank = "";
				}
			} else {
				guildRank = "";
			}
			if(indentUnguilded){
				return "<span class=\"guild" + friendlyGuild(guildTag) + "\">[<span>" + guildTag + "</span>" + guildRank + "]</span>";
			} else {
				return "<span class=\"guildNoIndent" + friendlyGuild(guildTag) + "\">[<span>" + guildTag + "</span>" + guildRank + "]</span>";
			}
		}
	}
	if(indentUnguilded && showGuildRank){
		return "<span class=\"guild\"></span>";
	} else {
		return "";
	}
}

function friendlyGuild(guildTag){
	guildTag = guildTag.toString()
	guildTag = guildTag.toLowerCase()
	if(guildHighlight == undefined){guildHighlight = "";}
	guildHighlight = guildHighlight.toString()
	guildHighlight = guildHighlight.toLowerCase()
	
	if(guildTag == guildHighlight){
		return " friendlyGuild";
	} else {
		return "";
	}
}



//Thanks to FiReMaGe for making this for me.
function array_toSet (a) {
	var s = {};
	for (var i in a) { if(i != "each"){s[a[i]] = true;}}
	return s;
}

function set_toArray (s) {
	var a = [];
	for (var m in s) { if(m != "each"){a.push(m);}}
	return a;
}

function createJoinPart () {
	part = onlineOld;
	join = {};
	onlineNowList = onlineNow['itani'].concat(onlineNow['serco'],onlineNow['uit'],onlineNow['unaligned'])
	for (var i in onlineNowList) {
		var name = onlineNowList[i];
		var exists = part[name];
		delete part[name];
		if (!exists) { join[name] = true; }
	}
	join = set_toArray(join);
	part = set_toArray(part);
}

function assembleGuildList(list){
	sendDebug("Assembling guild list.")
	list = list.split(key);
	i = 0;
	while(list[i]){
		var guild = list.splice(0,1);
		var name = list.splice(0,1);
		var rank = list.splice(0,1);
		if(rank && guild && name){
			playersInGuild[name] = new Array();
			playersInGuild[name]["guild"] = guild;
			playersInGuild[name]["rank"] = rank;
		}
	}
}