var focusName = "";
var foeList = new Array();
var friendList = new Array();

function openFriendWindow(name){
	focusName = unescape(name);
	$('fwName').innerHTML = focusName;
	friendOpacityChange.start(1);
	contentOpacityChange.start(0);
	
	fwFoeB.setEnabled(true)
	$('fwFoe').style.opacity = 1;
	fwFriendB.setEnabled(true)
	$('fwFriend').style.opacity = 1;
	fwNeutralB.setEnabled(true)
	$('fwNeutral').style.opacity = 1;
	
	if(isFriend(focusName)){
		fwFriendB.setEnabled(false)
		$('fwFriend').style.opacity = .3;
	} else if (isFoe(focusName)){
		fwFoeB.setEnabled(false)
		$('fwFoe').style.opacity = .3;
	} else {
		fwNeutralB.setEnabled(false)
		$('fwNeutral').style.opacity = .3;
	}
}

function closeFriendWindow(){
	friendOpacityChange.start(0);
	contentOpacityChange.start(1);
}

function friendWindowSelect(type){
	switch(type){
		case 1: makeFriend(focusName); break;
		case 2: makeFoe(focusName); break;
		case 3: makeNeutral(focusName); break;
		default: closeFriendWindow(); break;
	}
}

function makeFriend(name){
	if(isFoe(name)){
		removeFoe(name)
	}
	if(isFriend(name)){
		return;
	}
	//add to friend list
	friendList.push(name)
	saveFriendly()
	closeFriendWindow()
}

function makeFoe(name){
	if(isFoe(name)){
		return;
	}
	if(isFriend(name)){
		removeFriend(name)
	}
	//add to foe list
	foeList.push(name)
	saveFriendly()
	closeFriendWindow()
}

function makeNeutral(name){
	if(isFoe(name)){
		removeFoe(name)
	}
	if(isFriend(name)){
		removeFriend(name)
	}
	saveFriendly()
	closeFriendWindow()
}

function removeFriend(name){
	for(var i = 0; i < friendList.length; i++){
		if(friendList[i].toString().toLowerCase() == name.toString().toLowerCase()){
			 friendList.splice(i,1);
			 i--;
		}
	}
	saveFriendly()
}

function removeFoe(name){
	for(var i = 0; i < foeList.length; i++){
		if(foeList[i].toString().toLowerCase() == name.toString().toLowerCase()){
			 foeList.splice(i,1);
			 i--;
		}
	}
	saveFriendly()
}


function isFriend(name){
	name = name.toString().toLowerCase()
	for(var i = 0; i < friendList.length; i++){
		if(friendList[i].toString().toLowerCase() == name){
			return true;
		}
	}
	return false;
}

function isFoe(name){
	name = name.toString().toLowerCase()
	for(var i = 0; i < foeList.length; i++){
		if(foeList[i].toString().toLowerCase() == name){
			return true;
		}
	}
	return false;
}

function saveFriendly(){
	createNationDisplay()
	saveList(friendList,"friendsList")
	saveList(foeList,"foesList")
}


function makeFriendlyList(list,type){
	var output = "<ul class=\"leList\">"
	for(var i in list){
		if(i == "each"){break;}
		if(list[i].toString().search(/;/) == -1){
			output+= "<li><img class=\"removeButton\" src=\"Images/delete.png\" onclick=\"leConfirmWindow('"+ escape(list[i]) + "','remove','" + type + "')\"/><span>" + list[i] + "</span></li>"
		}
	}
	output += "</ul><div id='endOfFriendly'></div>"
	return output;
}

function confirmRemove(type,name){
	$("confirmRemoveQuestion").innerHTML = "<h3>Really remove \"" + name + "\" from " + type + "list?</h3>"
	name = unescape(name);
}


