var nationV = new Array();
nationV[0] = new Array("itani",true);
nationV[1] = new Array("serco",true);
nationV[2] = new Array("uit",true);
nationV[3] = new Array("unaligned",true);
var tips

var nationE
var contentOpacityChange, logoOpacityChange, nationsEffect, errorOpacityChange, friendOpacityChange, prefOpacityChange, confirmOpacityChange, indicatorOpacityChange, leOpacityChange;

function createEffects(){
	contentOpacityChange = new Fx.Style('content', 'opacity', {duration:500});
	logoOpacityChange = new Fx.Style('startLogo', 'opacity', {duration:500});
	friendOpacityChange = new Fx.Style('friendWindow', 'opacity', {duration:500});
	errorOpacityChange = new Fx.Style('error', 'opacity', {duration:500});

	prefOpacityChange = new Fx.Style('backContent', 'opacity', {duration:500, onComplete: switchPane});
	leOpacityChange = new Fx.Style('listEditor','opacity', {duration:500});
	confirmOpacityChange = new Fx.Style('leConfirmWindow', 'opacity', {duration:500});
	confirmOpacityChange.set(0);	

	indicatorOpacityChange = new Fx.Style('loadIndicator', 'opacity', {duration:500});	

	errorOpacityChange.set(0);
	friendOpacityChange.set(0);
	contentOpacityChange.set(0);
	
	nationE = $$('#nationScrollArea .nation')
	nationsEffect = new Fx.Elements(nationE, {wait: true, duration:1000, unit: '%', transition: Fx.Transitions.Expo.easeIn, onComplete: ensureHidden});
	nationsEffect.set({
		'0': {'width': [25*nationIsShown(0)]},
		'1': {'width': [25*nationIsShown(1)]},
		'2': {'width': [25*nationIsShown(2)]},
		'3': {'width': [25*nationIsShown(3)]}
	});
	

}

function ensureHidden(){
	width = getColumnWidth()
	nationsEffect.set({
		'0': {'width': [width*nationIsShown(0)]},
		'1': {'width': [width*nationIsShown(1)]},
		'2': {'width': [width*nationIsShown(2)]},
		'3': {'width': [width*nationIsShown(3)]}
	});
	
	gNationScrollArea.refresh();
	
	
}

function getColumnWidth(){
	if(forceSingleColumn){
		return 100;
	} else {
		var showThese = new Array();

		for(var i = 0; i<nationV.length; i++){
			if(nationV[i][1]){
				showThese.push(i);
			}
		}
		return (100 / showThese.length);
	}
}


function setNationVisibility(nationId,boo){
	nationsEffect.stop();
	
	var oldColumnWidth = getColumnWidth();
	
	if(nationId >= 0){
		nationV[nationId][1] = boo;
	}

	var newColumnWidth = getColumnWidth();
	
	nationId = nationId.toString()
	nationsEffect.start({
		'0': {
			'opacity': [1*nationIsShown(0)],
			'width': [newColumnWidth*nationIsShown(0)]
		},
		'1': {
			'opacity': [1*nationIsShown(1)],
			'width': [newColumnWidth*nationIsShown(1)]
		},
		'2': {
			'opacity': [1*nationIsShown(2)],
			'width': [newColumnWidth*nationIsShown(2)]
		},
		'3': {
			'opacity': [1*nationIsShown(3)],
			'width': [newColumnWidth*nationIsShown(3)]
		}
	});
	
}

function nationIsShown(nationId){
	if(nationV[nationId][1] == true){
		return 1;
	} else {
		return 0;
	}
}
var indicatorTimer;
var indicatorSwitch = 0;
function startIndicatorPulse(){
	indicatorTimer = (function(){toggleIndicatorOpacity()}).periodical(105);
	toggleIndicatorOpacity()
}

function toggleIndicatorOpacity(){
	//indicatorOpacityChange.set(indicatorSwitch)
	if(indicatorSwitch > 0){indicatorSwitch = 0;}else{indicatorSwitch = 1;}
	indicatorOpacityChange.start(indicatorSwitch);
}

function stopIndicatorPulse(){
	$clear(indicatorTimer);
	indicatorOpacityChange.stop()
	indicatorSwitch = 0;
	indicatorOpacityChange.start(indicatorSwitch);
}